//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "AboutForm.h"
#include "TestForm.h"
#include "OptionsForm.h"
#include "Edit.h"
#include "Prop.h"

#include <inifiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

int ProgramState;
BOOL bDelButton;
BOOL bObjectModified;
BOOL bCancel;
BOOL bNewCancel;     // true          
 TList* ObjFileList;  // .lbj
 TList* LevObjList;  //   
 Graphics::TBitmap *ObjBmp;  //  
 int ItemLen, ItemHgt, HorisItems;
 int objnom;

TFileStream* ObjFile;   // 

String LevelFileName;    //    
String ObjectFile;  //  


TMainForm *MainForm;
void GetTypeObjectInfo(int type, RECT* src,Graphics::TBitmap* bmp);
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
    ItemLen=16;
    ItemHgt=16;
    HorisItems=4;
    ItemFile="";

    TIniFile *ini;
    ini = new TIniFile(
      ChangeFileExt( Application->ExeName, ".INI" ) );
   Top     =  ini->ReadInteger( "Form", "Top", 100 );
   Left    =  ini->ReadInteger( "Form", "Left", 100 );
   if( ini->ReadBool( "Form", "InitMax", false ) )
         WindowState = wsMaximized;
   else
         WindowState = wsNormal;
   delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutClick(TObject *Sender)
{
    About->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::Exit1Click(TObject *Sender)
{
    FileNewClick(Sender);
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileTestLevelClick(TObject *Sender)
{
    TestLevelForm->ShowModal();
}
//---------------------------------------------------------------------------
void TMainForm::AlignObject()
{
    if( VTop->Checked ) MouseY  -= MouseY%ItemHgt;
    if( HLeft->Checked ) MouseX -= MouseX%ItemLen;

    if( VBottom->Checked)MouseY += ItemHgt-(MouseY+curObjhgt)%ItemHgt;
    if( HRight ->Checked)MouseX += ItemLen-(MouseX+curObjlen)%ItemLen;

}

//  bNewCancel false     true        
void __fastcall TMainForm::FileNewClick(TObject *Sender)
{
    bNewCancel = false;

    //  
    if(bLevelModified) //   
    {
        int result=Application->MessageBox(
            "The current level has changed. Save changes?",
            "Level Editor", MB_YESNOCANCEL | MB_ICONWARNING);
        if(result == IDYES) FileSaveClick(Sender);
        if(result==  IDCANCEL)
        {
            bNewCancel = true;
            return;
        }
    }

    //   
    if(bObjectModified) //   
    {
        int result=Application->MessageBox(
            "The object's data was modified. Save changes?",
            "Level Editor", MB_YESNOCANCEL | MB_ICONWARNING);
        if(result == IDYES)
        {
        if(ObjectFile=="")
        {   //     
            SaveObjectAsDialog->Title="Save Objects data";
            if(SaveObjectAsDialog->Execute() )
            ObjectFile=SaveObjectAsDialog->FileName;
            else ObjectFile="objects.lbj";
        }
        SaveObjectFile(ObjectFile);
        }

        if(result == IDCANCEL)
        {
            bNewCancel = true;
            return;
        }
    }

    //  
    LevelFileName="";
    ObjectFile="";
    SaveDialog->FileName="";

    //   
    memset( (void*)Levdat, NULL, MAXTILES_X*MAXTILES_Y);

    //  
   if( LevObjList->Count)
    {
        for(int n=0;n<LevObjList->Count; n++)
        delete (LEVFILEOBJECT*)LevObjList->Items[n];
    LevObjList->Clear();
    }
    //   
    if( ObjFileList->Count)
    {
        for(int n=0;n<ObjFileList->Count; n++)
        delete (OBJECTFILEOBJECT*)ObjFileList->Items[n];
    ObjFileList->Clear();
    }

    //   
    ProgramState=PS_NONE;
    bLevelModified=false;
    bObjectModified=false;
    bMouseDown=false;
    Levposx=0;
    Levposy=0;
    CurItem=0;
    curObjtype=0;
    curObjparam=0;
    ItemPaintFirst=0;
    //    
    LH.ItemLen=ItemLen;
    LH.ItemHgt=ItemHgt;
    LH.HorisItems=HorisItems;

    PostMessage(Handle, WM_PAINT, 0, 0);
}
//---------------------------------------------------------------------------
void GetTypeObjectInfo(int type, RECT* src,Graphics::TBitmap* bmp)
{
    //     .lbj
    //,  bmp 
    String objstring;
    int m,wi,he;
    BOOL bFinded=false;

    src->left=0;
    src->top=0;

for(m=0; m<ObjFileList->Count; m++) //  ObjFileList   type
{
    if( ((OBJECTFILEOBJECT*)ObjFileList->Items[m])->type != type) continue;
    bFinded=true;  // 

    wi=((OBJECTFILEOBJECT*) ObjFileList->Items[m] )->len;
    he=((OBJECTFILEOBJECT*) ObjFileList->Items[m] )->hgt;

    if( ((OBJECTFILEOBJECT*)ObjFileList->Items[m])->bitmap[0] != 0 )
    //  bmp
    {
    bmp->LoadFromFile( ((OBJECTFILEOBJECT*)ObjFileList->Items[m])->bitmap );
    //  
    }
    else
    {
    //  
    bmp->Width=wi;
    bmp->Height=he;

    //     
    char buf[50];
    sprintf(buf, "%d",type );
    objstring=buf;
    bmp->Canvas->TextOut(0,0,objstring);
    }

src->right=wi;
src->bottom=he;

}


        if( !bFinded ) //    .lbj
        {
        //  
        bmp->Height=ItemHgt;
        bmp->Width=ItemLen;
        src->bottom=ItemHgt;
        src->right=ItemLen;
        //     
        char buf[50];
        sprintf(buf, "%d",type );
        objstring=buf;
        bmp->Canvas->TextOut(0,0,objstring);
        src->right=ItemLen;
        src->bottom=ItemHgt;
        }
}
//---------------------------------------------------------------------------
//  int SearchObject(int x,int y)
//    LevObjList   
//--------------------------------------------------------------
int SearchObject(int x,int y)
{
    RECT src;
    for(int n=0; n<LevObjList->Count; n++)
    {
    LEVFILEOBJECT*lo=(LEVFILEOBJECT*)LevObjList->Items[n];
    GetTypeObjectInfo(lo->type,&src,ObjBmp);   //len  hgt 

    src.left   +=lo->posx;
    src.right  +=lo->posx;
    src.top    +=lo->posy;
    src.bottom +=lo->posy;


    if( xyandsrc(x,y,&src) )return n; // x y  src
    }
    return (-1);
}
//---------------------------------------------------------------------------
BOOL xyandsrc(int x,int y,RECT* src)
{
    // x y  src  return true
    if( x < src->left  ) return false;
    if( x > src->right ) return false;
    if( y < src->top   ) return false;
    if( y > src->bottom) return false;
    return true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ItemBoxPaint(TObject *Sender)
{
    Graphics::TBitmap* itembitmap=new Graphics::TBitmap;
    itembitmap->Width=ItemLen;
    itembitmap->Height=ItemHgt;
    ItemPaintFirst=ItemScrollBar->Position;

    for(int n=0; n<5; n++)
    {
    int item=ItemPaintFirst+n;
    RECT src,dst;
    src.left=ItemLen*(item%HorisItems);
    src.top=ItemHgt*(item/HorisItems);
    src.right=src.left+ItemLen;
    src.bottom=src.top+ItemHgt;

    dst.left=48*n;
    dst.top=0;
    dst.right=dst.left+48;
    dst.bottom=dst.top+48;

    TRect itemdst=Rect(0,0,ItemLen,ItemHgt);
    itembitmap->Canvas->CopyRect(itemdst,ItemBmp->Canvas,src);
    ItemBox->Canvas->StretchDraw(dst, itembitmap);
    }
    delete itembitmap;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    Application->OnHint = &OnHint;
    ItemBmp=new Graphics::TBitmap;
    ObjBmp=new Graphics::TBitmap;
    GridBitmap=new Graphics::TBitmap;
    Levdat=(char*) new char[MAXTILES_X*MAXTILES_Y];
// 
    ObjFileList=new TList;
    LevObjList=new TList;
    FileNewClick(Sender);

    CreateGridBitmap();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::OnHint(TObject* Sender)
{
    StatusBar->SimpleText = Application->Hint;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ItemBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    MouseItem=X/48;
    static char buf[50];
    sprintf(buf,"Current item %d",
        MouseItem+ItemScrollBar->Position);
    Hint=buf;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ItemBoxClick(TObject *Sender)
{
    CurItem=MouseItem+ItemScrollBar->Position;
    ProgramState=PS_PUTITEM;
    bMouseDown=false;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PaintBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    int x,y,P;
    MouseX=X;
    MouseY=Y;
    RECT obj_rect,src,dst;

    MouseItemX=X/ItemLen;
    MouseItemY=Y/ItemHgt;
    static char buf[256];
    buf[0]=0;

    switch(ProgramState)
    {
    case PS_PUTITEM:
        if(bMouseDown)
        {
        x=Levposx+MouseItemX;
        y=Levposy+MouseItemY;
        if(x<MAXTILES_X && y<MAXTILES_Y) *(Levdat+MAXTILES_X*y+x)=(char)CurItem;
//     
//        PaintBoxPaint(Sender);
//  -  
        src.left=ItemLen*(CurItem%HorisItems);
        src.top=ItemHgt*(CurItem/HorisItems);
        src.right=src.left+ItemLen;
        src.bottom=src.top+ItemHgt;

        dst.left=MouseItemX*ItemLen;
        dst.top=MouseItemY*ItemHgt;
        dst.right=dst.left+ItemLen;
        dst.bottom=dst.top+ItemHgt;

        PaintBox->Canvas->CopyRect(dst, ItemBmp->Canvas,src);
        bLevelModified=true;
        }
        sprintf(buf,"|Put tile     x=%d     y=%d     tyle=%d",MouseItemX+Levposx,
        MouseItemY+Levposy,CurItem);
        break;
    case PS_PUTOBJECT:
        PaintBoxPaint(Sender);
        //   ( MouseX  MouseY)
        AlignObject();

        PaintBox->Canvas->Pen->Style=psDot;
        obj_rect.left=MouseX;
        obj_rect.top=MouseY;
        obj_rect.right=MouseX+curObjlen;
        obj_rect.bottom=MouseY+curObjhgt;
        PaintBox->Canvas->FrameRect(obj_rect);

        sprintf(buf,"|Put object     x=%d     y=%d     type=%d    default param=%d",
            MouseX,
            MouseY,curObjtype,curObjparam);
        break;
    case PS_DELETEOBJECT:

        PaintBoxPaint(Sender);
        int n=SearchObject(Levposx*ItemLen+X, Levposy*ItemHgt+Y);

        if( n!= -1)
        {
        X=((LEVFILEOBJECT*)LevObjList->Items[n] )->posx;
        Y=((LEVFILEOBJECT*)LevObjList->Items[n] )->posy;
        int T=((LEVFILEOBJECT*)LevObjList->Items[n] )->type;
        int P=((LEVFILEOBJECT*)LevObjList->Items[n] )->param;
        GetTypeObjectInfo(T,&obj_rect,ObjBmp);

        obj_rect.left=X;
        obj_rect.top=Y;
        obj_rect.right+=X;
        obj_rect.bottom+=Y;

        PaintBox->Canvas->Pen->Style=psDot;
        PaintBox->Canvas->FrameRect(obj_rect);

        sprintf(buf,"|Delete object     x=%d     y=%d     type=%d   param=%d",
            X,Y,T,P);
        }
        else
        sprintf(buf,"Search target for delete");
        break;
    }
    Hint=buf;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PaintBoxClick(TObject *Sender)
{
    LEVFILEOBJECT* lo;
    int x,y,n;


    switch(ProgramState)
    {
    case PS_PUTOBJECT:
        x=Levposx*ItemLen+MouseX;
        y=Levposy*ItemHgt+MouseY;
        lo=new LEVFILEOBJECT;
        lo->posx=x;
        lo->posy=y;
        lo->type=curObjtype;
        lo->param=curObjparam;
        LevObjList->Add(lo);
        LH.KolObj=LevObjList->Count;
        bLevelModified=true;
        break;
    case PS_PUTITEM:
        x=Levposx+MouseItemX;
        y=Levposy+MouseItemY;
        if(x<MAXTILES_X && y<MAXTILES_Y) *(Levdat+MAXTILES_X*y+x)=(char)CurItem;
        PaintBoxPaint(Sender);
        bLevelModified=true;
        break;
    case PS_DELETEOBJECT:
        int n=SearchObject(Levposx*ItemLen+MouseX, Levposy*ItemHgt+MouseY);

        if(n != -1)
        {
        delete (LEVFILEOBJECT*) LevObjList->Items[n];
        LevObjList->Delete(n);
        PaintBoxPaint(Sender);
        }
        break;

    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PaintBoxPaint(TObject *Sender)
{
RECT cr=PaintBox->Canvas->ClipRect;
RECT src,dst;


    int ViewLen =( cr.right - cr.left )/ItemLen+1;
    int ViewHgt =( cr.bottom - cr.top)/ItemHgt+1;

Levposx=BottomScrollBar->Position;
Levposy=RightScrollBar->Position;
BottomScrollBar->Max=MAXTILES_X-ViewLen;
RightScrollBar->Max=MAXTILES_Y-ViewHgt;

//  
if(ViewGrid->Checked)
{
PaintBox->Canvas->CopyRect(cr, GridBitmap->Canvas,cr);
PaintBox->Canvas->CopyMode = cmSrcPaint	;
}


//  Item
    for(char y=0;y<ViewHgt;y++)
    for(char x=0;x<ViewLen;x++)
    {
    char item=GetTile(x+Levposx,Levposy+y);
    src.left=ItemLen*(item%HorisItems);
    src.top=ItemHgt*(item/HorisItems);
    src.right=src.left+ItemLen;
    src.bottom=src.top+ItemHgt;

    dst.left=x*ItemLen;
    dst.top=y*ItemHgt;
    dst.right=dst.left+ItemLen;
    dst.bottom=dst.top+ItemHgt;

    PaintBox->Canvas->CopyRect(dst, ItemBmp->Canvas,src);
    }

//  CopyMode
PaintBox->Canvas->CopyMode = cmSrcCopy;

//  
if(ViewLevelObject->Checked && LH.KolObj)
{
    RECT levrect;    //,objrect;

    levrect.left=Levposx*ItemLen;   //  
    levrect.top=Levposy*ItemHgt;    // 
    levrect.right=levrect.left+ ( cr.right - cr.left );
    levrect.bottom=levrect.top+ ( cr.bottom - cr.top);

    src.left=src.top=0;

    //     
    for(int n=0; n< LevObjList->Count ; n++)
    {
        // ,    levrect
        LEVFILEOBJECT* curobj=(LEVFILEOBJECT*) LevObjList->Items[n];
        if( curobj->posx     > levrect.right  )continue;
        if( curobj->posy     > levrect.bottom )continue;
//        if( curobj->posx+255 > levrect.left   )continue;
//        if( curobj->posy+255 > levrect.top    )continue;

        //  ,      rect
        dst.left=  curobj->posx  -  levrect.left;
        dst.top =  curobj->posy  -  levrect.top;

        //      
        //    
        GetTypeObjectInfo( curobj->type , &src, ObjBmp );
        dst.right  =dst.left + src.right;
        dst.bottom =dst.top  + src.bottom;

        PaintBox->Canvas->CopyRect(dst, ObjBmp->Canvas,src);
    }
}

}
//---------------------------------------------------------------------------
int TMainForm::GetTile(int x,int y)
{
if(x<0 || x>1023 || y<0 || y>1023 )return NULL;
return *(Levdat+y*MAXTILES_X+x);
}

//---------------------------------------------------------------------------
BOOL TMainForm::CheckLen(int x)
{
    //  false  
    //   false    
    for(int y=0; y<MAXTILES_Y;y++)
    if( GetTile(x-1,y) )
        return true;
    return false;
}
BOOL TMainForm::CheckHgt(int y)
{   //  false  
    for(int x=0; x<MAXTILES_X;x++)
    if( GetTile(x,y-1) )
        return true;
    return false;
}
//-------------------------------------------------------
void __fastcall TMainForm::FileSaveClick(TObject *Sender)
{
    //     ,    
    if( LevelFileName != "")
    {
        SaveLevel();
    }
    else
        //    ,   " ..."
        FileSaveAsClick(Sender);
}
//---------------------------------------------------------------------------
void TMainForm::SaveLevel()
{

    //     
    LevFile=new TFileStream( LevelFileName, fmCreate );
    //     
    memcpy(&LH.ItemFile,ItemFile.c_str(),ItemFile.Length()+1 );
    memcpy(&LH.ObjectFile,ObjectFile.c_str(),ObjectFile.Length()+1 );
    LH.KolObj=LevObjList->Count;
    LH.ItemLen=ItemLen;
    LH.ItemHgt=ItemHgt;
    LH.HorisItems=HorisItems;

    //      , 
    //   LevLen  LevHgt
    if( !LH.bFixedLen)
    {
        LH.LevLen=MAXTILES_X;
        while( !CheckLen(LH.LevLen) && LH.LevLen>2)LH.LevLen--;
    }
    if( !LH.bFixedHgt)
    {
        LH.LevHgt=MAXTILES_Y;
        while( !CheckHgt( LH.LevHgt) && LH.LevHgt>2)LH.LevHgt--;
    }

    //  
    LevFile->Write(&LH, sizeof(LEVELFILEHEADER) );

    // 
    for( int y=0; y<LH.LevHgt; y++)
        LevFile->Write(Levdat+MAXTILES_X*y,LH.LevLen );

    //     
    if( LH.KolObj )
    {
        for( int n=0; n<LH.KolObj; n++)
            LevFile->Write(LevObjList->Items[n],sizeof(LEVFILEOBJECT) );
    }

    //   
    delete LevFile;

    //   
    bLevelModified=false;


    /*     */

    //     
    if(bObjectModified)
    {
        //      
        if( ObjectFile=="" )
        {   //    
            SaveObjectAsDialog->Title="Save Objects info";
            if( SaveObjectAsDialog->Execute() )
            {
                ObjectFile=SaveObjectAsDialog->FileName;
                SaveObjectFile(ObjectFile);
            }
        }
        else
            //     
            SaveObjectFile(ObjectFile);
    }
}
//-----------------------------------------------------------------

void __fastcall TMainForm::EditOptionsClick(TObject *Sender)
{
    Options->ShowModal();

    //  TComboBox  ObjectBox
    MainForm->ObjectBox->Clear();
    for(int n=0; n< ObjFileList->Count; n++) //  TMainForm.ObjFileList   type
        MainForm->ObjectBox->Items->AddObject(
        ((OBJECTFILEOBJECT*)ObjFileList->Items[n] )->objname,
        (System::TObject*)ObjFileList->Items[n] );

    PostMessage(Handle, WM_PAINT, 0, 0);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSaveAsClick(TObject *Sender)
{
    SaveDialog->Title="Save As";

    if(SaveDialog->Execute())
    {
        LevelFileName = SaveDialog->FileName;
        MainForm->Caption = LevelFileName+" - Level Editor";

        SaveLevel();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormPaint(TObject *Sender)
{
    PaintBoxPaint(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ViewLevelObjectClick(TObject *Sender)
{
    ViewLevelObject->Checked=!ViewLevelObject->Checked;
    PaintBoxPaint(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::ViewGridClick(TObject *Sender)
{
    ViewGrid->Checked=!ViewGrid->Checked;
    CreateGridBitmap();
    PaintBoxPaint(Sender);
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FileOpenClick(TObject *Sender)
{
        //     
        // (     )
        FileNewClick(Sender);

        //       
        //     
        //  
        if( bNewCancel == true )
            return;

    OpenDialog->Title="Open Level";

    if( OpenDialog->Execute() )
    {
        //    
        try
        {
        LevFile=new TFileStream(OpenDialog->FileName,fmOpenRead);
        }
        catch (Exception &exception)
        {
            Application->ShowException(&exception);
            return;
        }

        //    
        LevelFileName = OpenDialog->FileName;
        SaveDialog->FileName = LevelFileName;


        LevFile->Read(&LH, sizeof(LEVELFILEHEADER) );

        // 
        ItemFile=LH.ItemFile;
        ObjectFile=LH.ObjectFile;
        ItemLen=LH.ItemLen;
        ItemHgt=LH.ItemHgt;
        HorisItems=LH.HorisItems;

        for(int y=0; y<LH.LevHgt ; y++)
        {
            LevFile->Read(Levdat+MAXTILES_X*y,LH.LevLen );
        }

        //    
        if( LH.KolObj )
        {
            LEVFILEOBJECT* lobj;
            for( int n=0; n<LH.KolObj;n++)
            {
                lobj=new LEVFILEOBJECT;
                LevFile->Read(lobj,sizeof(LEVFILEOBJECT) );
                LevObjList->Add(lobj);
            }
        }

        //  
        delete LevFile;

        //       
        //   
        try
        {
            ItemBmp->LoadFromFile(ItemFile);
        }
        catch (Exception &exception)
        {
            char buf[500];
            sprintf(buf,"    \n%s.\n   .",ItemFile.c_str() );
            MessageBox(Handle,buf, "  " ,MB_OK );

            if(Options->OpenPictureDialog1->Execute())
            {
                ItemFile=Options->OpenPictureDialog1->FileName;
                ItemBmp->LoadFromFile(ItemFile);
            }
        }

        //    .lbj
        try
        {
            LoadObjectFile(ObjectFile);
        }
        catch (Exception &exception)
        {
            char buf[500];
            sprintf(buf,"     \n%s.\n   .",ObjectFile.c_str() );
            MessageBox(Handle,buf, "  " ,MB_OK );

            if(Options->OpenDialog2->Execute())
           {
                ObjectFile=Options->OpenDialog2->FileName;
                LoadObjectFile(ObjectFile);
           }
        }

        //  TComboBox  ObjectBox
        ObjectBox->Clear();
        for(int n=0; n< ObjFileList->Count; n++) //  TMainForm.ObjFileList   type
            ObjectBox->Items->AddObject( ((OBJECTFILEOBJECT*)ObjFileList->Items[n] )->objname,
                                         (System::TObject*)ObjFileList->Items[n] );

        //  
        PostMessage(Handle, WM_PAINT, 0, 0);
        ItemBoxPaint(Sender);
        MainForm->Caption=SaveDialog->FileName+" - Level Editor";
    }// end if(Dialog->Execute)
}
//----------------------------------------------------------
void LoadObjectFile(String name)
{
    if(name=="")return;
    WORD ObjFileKolObj;

    //   
    if( ObjFileList->Count)
    {
        for(int n=0;n<ObjFileList->Count; n++)
        delete (OBJECTFILEOBJECT*)ObjFileList->Items[n];
    ObjFileList->Clear();
    }
    //   ,   
    if(name != "")
    {
    ObjFile=new TFileStream( name , fmOpenRead);

    // 
    ObjFile->Read(&ObjFileKolObj,sizeof(WORD) );

    //       
    if( ObjFileKolObj )
    {
        OBJECTFILEOBJECT* lobj;
        for( int n=0; n<ObjFileKolObj;n++)
        {
        lobj=new OBJECTFILEOBJECT;
        ObjFile->Read(lobj,sizeof(OBJECTFILEOBJECT) );
        ObjFileList->Add(lobj);
        }
    }

    delete ObjFile;
    }
}

//--------------------------------------------------------
void SaveObjectFile(String name)
{
WORD ObjFileKolObj=ObjFileList->Count;

TFileStream* ObjFile=new TFileStream( name , fmCreate);

// 
ObjFile->Write(&ObjFileKolObj,sizeof(WORD) );

//       
if( ObjFileKolObj )
    {
    for( int n=0; n<ObjFileKolObj;n++)
        ObjFile->Write(ObjFileList->Items[n],sizeof(OBJECTFILEOBJECT) );
    }

delete ObjFile;
bObjectModified=false;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::DeleteObjectButtonClick(TObject *Sender)
{
        ProgramState=PS_DELETEOBJECT;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::DeleteObjectButtonDblClick(TObject *Sender)
{
    ProgramState=PS_DELETEOBJECT;
    //DeleteObjectButton->Down=true;
    bDelButton=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
    delete ObjFileList;
    delete LevObjList;
    delete ItemBmp;
    delete ObjBmp;
    delete GridBitmap;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::VNoneClick(TObject *Sender)
{
    VNone->Checked= true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::VTopClick(TObject *Sender)
{
    VTop->Checked=true;
//    VTopClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::VBottomClick(TObject *Sender)
{
    VBottom->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HNoneClick(TObject *Sender)
{
    HNone->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HLeftClick(TObject *Sender)
{
    HLeft->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HRightClick(TObject *Sender)
{
    HRight->Checked=true;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ObjectBoxChange(TObject *Sender)
{
//    
//  Program State=PS_PUTOBJECT
  TComboBox *pCB = dynamic_cast<TComboBox *>(Sender);

if (pCB)
    {
    OBJECTFILEOBJECT *pLFO =(OBJECTFILEOBJECT *)(pCB->Items->Objects[pCB->ItemIndex]);

    curObjtype=(pLFO->type);
    curObjlen= (pLFO->len);
    curObjhgt= (pLFO->hgt);
    curObjparam = (pLFO->param);

    ProgramState=PS_PUTOBJECT;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::AddObjectSpeedButtonClick(TObject *Sender)
{

EditObjectForm->ShowModal();

    //  TComboBox  ObjectBox
    ObjectBox->Clear();
    //  
    for(int n=0; n< ObjFileList->Count; n++)
        ObjectBox->Items->AddObject(
            ((OBJECTFILEOBJECT*)ObjFileList->Items[n] )->objname,
            (System::TObject*)ObjFileList->Items[n] );
    ProgramState=PS_NULL;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
  Action = caFree;

//   
  TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
   ini->WriteInteger( "Form", "Top", Top );
   ini->WriteInteger( "Form", "Left", Left );
   ini->WriteBool   ( "Form", "InitMax",
                       WindowState == wsMaximized );

   delete ini;

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SpeedButton1Click(TObject *Sender)
{
FileNewClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpeedButton2Click(TObject *Sender)
{
FileOpenClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpeedButton3Click(TObject *Sender)
{
    FileSaveClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SpeedButton4Click(TObject *Sender)
{
    FileTestLevelClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSaveObjectsAsClick(TObject *Sender)
{
    SaveObjectAsDialog->Title="Save Objects Data As";
    if(SaveObjectAsDialog->Execute() )
    {
    SaveObjectFile( SaveObjectAsDialog->FileName );
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::PaintBoxMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    bMouseDown=false;
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::PaintBoxMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if( Button==mbLeft )
        bMouseDown=true;

    if( Button==mbRight ) {
        ProgramState=PS_NULL;
        Hint="";
        PaintBoxPaint(Sender);
    }

}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
  CanClose = True;
  if ( bLevelModified)
    switch (MessageDlg("Would you like to save changes to the level?",
                       mtConfirmation,
                       TMsgDlgButtons() << mbYes <<  mbNo << mbCancel,
                       0)){
      case mrYes:
          FileSaveClick(Sender);
          break;
      case mrCancel:
          CanClose = False;
          break;
    }
//  
  if ( bObjectModified)
    switch (MessageDlg("Would you like to save changes to the object's data?",
                       mtConfirmation,
                       TMsgDlgButtons() << mbYes <<  mbNo << mbCancel,
                       0)){
      case mrYes:
          if(ObjectFile=="")
          {   //     
            SaveObjectAsDialog->Title="Save Objects data";
            if(SaveObjectAsDialog->Execute() )
            ObjectFile=SaveObjectAsDialog->FileName;
            else ObjectFile="objects.lbj";
          }

          SaveObjectFile(ObjectFile);
          break;
      case mrCancel:
          CanClose = False;
          break;
    }



}
//---------------------------------------------------------------------------


void __fastcall TMainForm::PaintBoxDblClick(TObject *Sender)
{
int n=SearchObject(Levposx*ItemLen+MouseX, Levposy*ItemHgt+MouseY);

if(n != -1)
{
    objnom=n;
//    LEVFILEOBJECT* obj=(LEVFILEOBJECT*) LevObjList->Items[n];
    ObjectProp->ShowModal();
//        PaintBoxPaint(Sender);
}

    ProgramState=PS_NULL;
}
//---------------------------------------------------------------------------
void TMainForm::CreateGridBitmap()
{
    RECT cr=PaintBox->Canvas->ClipRect;

    GridBitmap->Width=cr.right-cr.left;
    GridBitmap->Height=cr.bottom-cr.top;

    GridBitmap->Canvas->Brush->Color = clBlack;
    GridBitmap->Canvas->Brush->Style = bsSolid;
    GridBitmap->Canvas->FillRect(GridBitmap->Canvas->ClipRect);

    GridBitmap->Canvas->Pen->Color=clBlue;
    GridBitmap->Canvas->Pen->Style=psInsideFrame;
    for(int x=0;x<cr.right;x+=ItemLen)
        {
        GridBitmap->Canvas->MoveTo(x,0);
        GridBitmap->Canvas->LineTo(x,(cr.bottom) );
        }
    for(int y=0;y<cr.bottom;y+=ItemHgt)
        {
        GridBitmap->Canvas->MoveTo(0,y);
        GridBitmap->Canvas->LineTo(cr.right,y);
        }


}

void __fastcall TMainForm::FormResize(TObject *Sender)
{
    //      
//    CreateGridBitmap();
}
//---------------------------------------------------------------------------






void __fastcall TMainForm::Contents1Click(TObject *Sender)
{
const static int HELP_TAB = 15;

const static int CONTENTS_ACTIVE = -3;

Application->HelpCommand(HELP_TAB, CONTENTS_ACTIVE);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::SearchforHelpOn1Click(TObject *Sender)
{
const static int HELP_TAB = 15;

const static int SEARCH_ACTIVE = -1;

Application->HelpCommand(HELP_TAB, SEARCH_ACTIVE);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::Index1Click(TObject *Sender)
{
const static int HELP_TAB = 15;

const static int INDEX_ACTIVE = -2;

Application->HelpCommand(HELP_TAB, INDEX_ACTIVE);
}
//---------------------------------------------------------------------------

